/**
 * Example firmware linker script 
 * @author: Copyright 2009,2010 Thomas Reidemeister
 * @date: 2009.12.14
 * @file: firmware.ld
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
MEMORY
{
  sram     : ORIGIN = 0x10100000, LENGTH = 1M
}

SECTIONS
{
  /* business as usual */
  .text : 
  {
    *(.text)
    *(.rodata*)
  } > sram

  .data :
  {
    *(.data)
  } > sram

  .bss :
  {
    *(.bss)
  } > sram
  
  /* firmware's test registration routine */
  __REGISTER_TEST__ 0x10300000: 
  {
    *(__REGISTER_TEST__) 
  }
  
  /* shared test data goes here */
  __TEST_DATA__ 0x10400000: 
  {
    *(__TEST_DATA__) 
  }
}
